
package com.java2s.java.swing.common.pane;

import java.awt.BorderLayout;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.UIManager;

/**
 * @email yin_zhiguo@hotmail.com
 * @author yinzhiguo
 */
public class CheckboxListTestFrame extends javax.swing.JFrame {

    /** Creates new form CheckboxListTestFrame */
    public CheckboxListTestFrame() {
        initComponents();
        this.setSize(140, 230);
        this.setTitle("CheckboxList 测试");
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        centerPane = new javax.swing.JPanel();
        testButPane = new javax.swing.JPanel();
        testBut = getButtonBy("test");

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        centerPane.setLayout(new java.awt.BorderLayout());

        testButPane.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        testBut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                testButActionPerformed(evt);
            }
        });
        testButPane.add(testBut);

        centerPane.add(testButPane, java.awt.BorderLayout.PAGE_END);

        prepareCheckboxListPane();

        getContentPane().add(centerPane, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

     /**
     * 根据ID返回JButton的实例
     * @param id 标识字符串
     * @return 按钮实例
     */
    public JButton getButtonBy(String id){

        JButton but = new JButton();
        if("test".equals(id)){
             but.setText("测试");
             but.setToolTipText("测试");
        }
        return but;
    }

    private CheckboxList langList = null;
    
    class Book{
        private String title = "";
        private double price = 0.0;

        public String getTitle() {
            return title;
        }

        public void setTitle(String title) {
            this.title = title;
        }

        public double getPrice() {
            return price;
        }

        public void setPrice(double price) {
            this.price = price;
        }
    }
    
    private void prepareCheckboxListPane() {
        
        Book t = new Book();
        t.setTitle("Java大全");
        t.setPrice(20.5);
        
        Book t1 = new Book();
        t1.setTitle("PHP大全");
        t1.setPrice(30.5);
        
        Book t2 = new Book();
        t2.setTitle("C++大全");
        t2.setPrice(50.5);
        
        Book t3 = new Book();
        t3.setTitle("Python大全");
        t3.setPrice(30.5);
        
        Book t4 = new Book();
        t4.setTitle("Perl大全");
        t4.setPrice(23.5);
        
        Book t5 = new Book();
        t5.setTitle("SmallTalk大全");
        t5.setPrice(23.5);
        
        Book t6 = new Book();
        t6.setTitle("Ruby大全");
        t6.setPrice(23.5);
        
        Book t7 = new Book();
        t7.setTitle("Lisp大全");
        t7.setPrice(23.5);
        
        Book t8 = new Book();
        t8.setTitle("Shell大全");
        t8.setPrice(23.5);
        
        Book[] ts = {t,t1,t2,t3,t4,t5,t6,t7,t8};
        
        langList = new CheckboxList(ts){
            @Override
            public Object getDataLabel(Object data){
                Book a = (Book)data;
                return a.getTitle();
            }
        };
        centerPane.add(langList, BorderLayout.CENTER);
    }
    
private void testButActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_testButActionPerformed
// TODO add your handling code here:
    ArrayList as = langList.getSelectedData();
    if(as.isEmpty()){
        JOptionPane.showMessageDialog(this, "您什么都没有选择！", "信息", JOptionPane.INFORMATION_MESSAGE);
    }else{
        StringBuffer sub = new StringBuffer();
        sub.append("<html>");
        sub.append("<b>您选择了：</b><br>");
        sub.append("<ul>");
        for(Object o : as){
            Book b = (Book)o;
            sub.append("<li>" + b.getTitle() + ", " + b.getPrice() + "</li>");
        }
        sub.append("</ul>");
        sub.append("</html>");
        JOptionPane.showMessageDialog(this, sub.toString(), "信息", JOptionPane.INFORMATION_MESSAGE);
    }
}//GEN-LAST:event_testButActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        UIManager.put("swing.boldMetal", Boolean.FALSE);
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                CheckboxListTestFrame cltf = new CheckboxListTestFrame();
                SwingUtil.setLocationToCenterOfScreen(cltf);
                cltf.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel centerPane;
    private javax.swing.JButton testBut;
    private javax.swing.JPanel testButPane;
    // End of variables declaration//GEN-END:variables

}
